#!/bin/sh
# Start up file for pppoe

. /ysdisk/etc/network/pppoe.conf

PPPOELOG_LAN="/ysdisk/syslog/pppoe_lan.log"
PPPOELOG_WAN="/ysdisk/syslog/pppoe_wan.log"
ISRUN=`ps | grep /bin/pppd | grep -v grep | wc -l`;
if [[ -n "$NIC_LAN" ]] ;
then
	ISRUN_LAN=`ps | grep /bin/pppd | grep $NIC_LAN | grep -v grep | wc -l`;
	CHECKPID_LAN=`ps | grep '/ysbin/checkpppoe.sh' | grep $NIC_LAN | grep -v grep |awk '{print$1}'|tr -d "\n"`;
	PPPDPID_LAN=`ps |grep "/bin/pppd" | grep $NIC_LAN |grep -v grep |awk '{print$1}'|tr -d "\n"`;
	DHCPCDPID_LAN=0
else
	ISRUN_LAN=0
	CHECKPID_LAN=0
	PPPDPID_LAN=0
	DHCPCDPID_LAN=0
	. /ysdisk/etc/network/lan.conf
	IF_LAN=$IF
	GW_LAN=$GATEWAY
	if [[ $DHCPD = "yes" ]]; then
		DHCPCDPID_LAN=`ps |grep "dhcpcd" | grep $IF_LAN |grep -v grep |awk '{print$1}'|tr -d "\n"`;
		if [[ -n "$DHCPCDPID_LAN" ]];then
		#may be static mode or not use.
			DHCPCDPID_LAN=0
		fi
	fi
fi
if [[ -n "$NIC_WAN" ]];
then
	ISRUN_WAN=`ps | grep /bin/pppd | grep $NIC_WAN | grep -v grep | wc -l`;
	CHECKPID_WAN=`ps | grep '/ysbin/checkpppoe.sh' | grep $NIC_WAN | grep -v grep |awk '{print$1}'|tr -d "\n"`;
	PPPDPID_WAN=`ps |grep "/bin/pppd" | grep $NIC_WAN |grep -v grep |awk '{print$1}'|tr -d "\n"`;
	DHCPCDPID_WAN=0
else
	ISRUN_WAN=0
	CHECKPID_WAN=0
	PPPDPID_WAN=0
	DHCPCDPID_WAN=0
	if [ -f /ysdisk/etc/network/wan.conf ];then
	#if it is in dual mode
		. /ysdisk/etc/network/wan.conf
		IF_WAN=$IF
		GW_WAN=$GATEWAY
		if [[ $DHCPD = "yes" ]]; then
			DHCPCDPID_WAN=`ps |grep "dhcpcd" | grep $IF_WAN |grep -v grep |awk '{print$1}'|tr -d "\n"`;
			if [[ -n "$DHCPCDPID_WAN" ]];then
			#may be static mode or not use.
				DHCPCDPID_WAN=0
			fi
		fi
	fi
fi
if [[ -n "$NIC_LAN" ]] && [[ -n "$NIC_WAN" ]]; then
	echo "$USERNAME_LAN * $PASSWORD_LAN *" > /etc/ppp/chap-secrets;
	echo "$USERNAME_LAN * $PASSWORD_LAN *" > /etc/ppp/pap-secrets;
	echo "$USERNAME_WAN * $PASSWORD_WAN *" >> /etc/ppp/chap-secrets;
	echo "$USERNAME_WAN * $PASSWORD_WAN *" >> /etc/ppp/pap-secrets;
elif [[ -n "$NIC_LAN" ]]; then
	echo "$USERNAME_LAN * $PASSWORD_LAN *" > /etc/ppp/chap-secrets;
	echo "$USERNAME_LAN * $PASSWORD_LAN *" > /etc/ppp/pap-secrets;
elif [[ -n "$NIC_WAN" ]]; then
	echo "$USERNAME_WAN * $PASSWORD_WAN *" > /etc/ppp/chap-secrets;
	echo "$USERNAME_WAN * $PASSWORD_WAN *" > /etc/ppp/pap-secrets;
fi
case $1 in
	start)	
		if [[ -n "$NIC_LAN" ]] ;
		then
			if [[ $ISRUN_LAN -le 0 ]];
			then
				/sbin/ifconfig $NIC_LAN up
				if [[ -n "$DEFAULTROUTE_LAN" ]];then
					/sbin/route del default >/dev/null &
					/bin/pppd pty "/bin/pppoe -I $NIC_LAN" user $USERNAME_LAN usepeerdns persist maxfail $MAXFAIL holdoff $HOLDOFF defaultroute pppdtype $PPPOELOG_LAN &
				else
					/bin/pppd pty "/bin/pppoe -I $NIC_LAN" user $USERNAME_LAN usepeerdns persist maxfail $MAXFAIL holdoff $HOLDOFF pppdtype $PPPOELOG_LAN &
				fi
				ln -sf /etc/ppp/resolv.conf /ysdisk/etc/resolv.conf
				ln -sf /etc/ppp/resolv.conf /ysdisk/etc/resolv.conf.head
				if [[ -z "$CHECKPID_LAN" ]];then
					#Do not run again.
					sh /ysbin/checkpppoe.sh $NIC_LAN > /dev/null &
				fi
			else
				echo "pppoe is running for $NIC_LAN";
			fi
		else
			echo "Didn't set LAN"
		fi
		if [[ -n "$NIC_WAN" ]];
		then
			if [[ $ISRUN_WAN -le 0 ]];
			then
				/sbin/ifconfig $NIC_WAN up
				if [[ -n "$DEFAULTROUTE_WAN" ]];then
				#the default gateway is set on ppp? about wan.
					/sbin/route del default >/dev/null &
					/bin/pppd pty "/bin/pppoe -I $NIC_WAN" user $USERNAME_WAN usepeerdns persist maxfail $MAXFAIL holdoff $HOLDOFF defaultroute pppdtype $PPPOELOG_WAN &
				else
					/bin/pppd pty "/bin/pppoe -I $NIC_WAN" user $USERNAME_WAN usepeerdns persist maxfail $MAXFAIL holdoff $HOLDOFF pppdtype $PPPOELOG_WAN &
				fi
				ln -sf /etc/ppp/resolv.conf /ysdisk/etc/resolv.conf
				ln -sf /etc/ppp/resolv.conf /ysdisk/etc/resolv.conf.head
				if [[ -z "$CHECKPID_WAN" ]];then
					#Do not run again.
					sh /ysbin/checkpppoe.sh $NIC_WAN > /dev/null &
				fi
			else
				echo "pppoe is running for $NIC_WAN";
			fi
		else
			echo "Didn't set WAN"
		fi
		;;
	stop)
		if [[ $ISRUN_LAN -gt 0 ]]; then
		#if run,and stop it.
			echo $PPPDPID_LAN "for $NIC_LAN"
			kill -9 $PPPDPID_LAN;
			kill -9 $CHECKPID_LAN
		fi
		if [[ $ISRUN_WAN -gt 0 ]]; then
		#if run,and stop it.
			echo $PPPDPID_WAN "for $NIC_WAN"
			kill -9 $PPPDPID_WAN;
			kill -9 $CHECKPID_WAN;
		fi
		sleep 1;
		if [[ $ISRUN_LAN -gt 0 ]] && [[ $ISRUN_WAN -gt 0 ]]; then
		#if wan and lan all have run pppoe,then there is nothing could do for default gateway.
			echo "Do nothing"
		else
		#if one of them have run pppoe,then we should adjust the defauld gw if it is need.
			if [[ $ISRUN_LAN -gt 0 ]] && [[ -n "$DEFAULTROUTE_LAN" ]] && [ -f /ysdisk/etc/network/wan.conf ]; then
			#if lan have run pppoe and wan is enable,then get default gateway for wan.
				if [[ $DHCPCDPID_WAN -gt 0 ]]; then
				#restart dhcpcd to get default gateway that have deleted at first.
					kill -9 $DHCPCDPID_WAN;
					/sbin/dhcpcd $IF_WAN > /dev/null &
				else
				#if wan is static mode,it is easy.
					if [[ -n "$GW_WAN" ]]; then
						/sbin/route add default gateway $GW_WAN dev $IF_WAN
					fi
				fi
			fi
			if [[ $ISRUN_WAN -gt 0 ]] && [[ -n "$DEFAULTROUTE_WAN" ]]; then
			#if wan have run pppoe,then get default gateway for lan.
				if [[ $DHCPCDPID_LAN -gt 0 ]]; then
				#restart dhcpcd to get default gateway that have deleted at first.
					kill -9 $DHCPCDPID_LAN;
					/sbin/dhcpcd $IF_LAN > /dev/null &
				else
				#if lan is static mode,it is easy.
					if [[ -n "$GW_LAN" ]]; then
						/sbin/route add default gateway $GW_LAN dev $IF_LAN
					fi
				fi
			fi
		fi
		;;
	restart) 
		if [ $ISRUN -gt 0 ];
		then
			if [[ $2 = $NIC_LAN ]] && [[ -n "$PPPDPID_LAN" ]] && [[ $PPPDPID_LAN -gt 0 ]]; then
				echo "Restart $NIC_LAN"
				kill $PPPDPID_LAN
				TMPPID=`ps |grep pppoe|grep $NIC_LAN|grep -v -e pppd -e sh -e grep|awk '{print$1}'|tr -d "\n"`
				echo "TMPPID=$TMPPID"
				if [[ -n "$TMPPID" ]] && [[ $TMPPID -gt 0 ]]; then
					kill $TMPPID
				fi
			elif [[ $2 = $NIC_WAN ]] && [[ -n "$PPPDPID_WAN" ]] && [[ $PPPDPID_WAN -gt 0 ]]; then
				echo "Restart $NIC_WAN"
				kill $PPPDPID_WAN
				TMPPID=`ps |grep pppoe|grep $NIC_WAN|grep -v -e pppd -e sh -e grep|awk '{print$1}'|tr -d "\n"`
				echo "TMPPID=$TMPPID"
				if [[ -n "$TMPPID" ]] && [[ $TMPPID -gt 0 ]]; then
					kill $TMPPID
				fi
			else
				# kill -9 $PPPDPID;
				killall -9 pppd;
				killall -9 pppoe;
			fi
		fi
		sleep 1;
		/bin/sh $0 start &
		;;
	enable)
		rm -f /persistent/etc/rc.d/S41pppoe; 
	        	ln -s /etc/init.d/pppoed /persistent/etc/rc.d/S41pppoe
	    ;;
	disable)
		rm -f /persistent/etc/rc.d/S41pppoe
		;;
        *) cat <<EOF;;
Syntax: /etc/init.d/pppoe [command]
Available commands:
        start   Start the service
        stop    Stop the service
        restart Restart the service
        enable  Enable service autostart
        disable Disable service autostart
EOF
esac

