#!/bin/sh
#
# manage HDVPSS Display firmware
PATH=$PATH:/usr/share/ti/ti-hdvpss-display-utils

case "$1" in
    start)
        echo "Loading HDVPSS Firmware"
        modprobe syslink
        sleep 1
        firmware_loader 2 /usr/share/ti/ti-hdvpss-display-utils/ti816x_hdvpss.xem3 start
        sleep 2
        modprobe vpss mode=hdmi:720p-60,dvo2:720p-60 debug=1
        modprobe ti81xxfb
        modprobe TI81xx_hdmi hdmi_mode=2
        sleep 1
        fbset -depth 32 -rgba 8/16,8/8,8/0,0/0
      ;;
    stop)
        echo "Unloading HDVPSS Firmware"
        rmmod TI81xx_hdmi
        rmmod ti81xxfb
        rmmod vpss
        firmware_loader 2 /usr/share/ti/ti-hdvpss-display-utils/ti816x_hdvpss.xem3 stop
        rmmod syslink
      ;;
    *)
        echo "Usage: /etc/init.d/load-firmware {start|stop}"
        exit 1
        ;;
esac

exit 0

